﻿/*
This file in the main entry point for defining Gulp tasks and using Gulp plugins.
Click here to learn more. http://go.microsoft.com/fwlink/?LinkId=518007
*/

// 1 Gulp - Required
var gulp = require("gulp"),
  rimraf = require("rimraf"),
  concat = require("gulp-concat"),
  cssmin = require("gulp-cssmin"),
  uglify = require("gulp-uglify");

// 2 Gulp -  Path
var paths = {
    webroot: "./wwwroot/"
};

paths.js = paths.webroot + "js/**/*.js";
paths.minJs = paths.webroot + "js/**/*.min.js";
paths.css = paths.webroot + "css/**/*.css";
paths.minCss = paths.webroot + "css/**/*.min.css";
paths.concatJsDest = paths.webroot + "js/site.min.js";
paths.concatCssDest = paths.webroot + "css/site.min.css";

// 2.5 Gulp - Default
gulp.task('default', function () {
    // place code for your default task here
});

// 3 Gulp - CleanJs
gulp.task("clean:js", function (cb) {
    rimraf(paths.concatJsDest, cb);
});

// 4 Gulp - CleanCss 
gulp.task("clean:css", function (cb) {
    rimraf(paths.concatCssDest, cb);
});

// 5 Gulp - Combine CleanJs and CleanCss
gulp.task("clean", ["clean:js", "clean:css"]);

// 6 Gulp - Javascript Min
gulp.task("min:js", function () {
    return gulp.src([paths.js, "!" + paths.minJs], { base: "." })
      .pipe(concat(paths.concatJsDest))
      .pipe(uglify())
      .pipe(gulp.dest("."));
});

// 7 Gulp - Css Min
gulp.task("min:css", function () {
    return gulp.src([paths.css, "!" + paths.minCss])
      .pipe(concat(paths.concatCssDest))
      .pipe(cssmin())
      .pipe(gulp.dest("."));
});

// 8 Gulp - Combine min:js and min:css
gulp.task("min", ["min:js", "min:css"]);



